ProceduralField< Data_T > Class Template Referenceabstract
Fields

`#include <ProceduralField.h>`

Inheritance diagram for ProceduralField< Data_T >:

## Public Types

typedef ProceduralField< Data_T > | class_type
typedef ProceduralFieldLookup< Data_T > | CubicInterp
typedef ProceduralFieldLookup< Data_T > | LinearInterp
typedef boost::intrusive_ptr< ProceduralField > | Ptr
Public Types inherited from Field< Data_T >
typedef Field< Data_T > | class_type
typedef boost::intrusive_ptr< Field > | Ptr
typedef Data_T | value_type
| Allows us to reference the template class.
typedef std::vector< Ptr > | Vec
| This is a convenience typedef for the list that Field3DInputFile::readScalarLayers() and Field3DInputFile::readVectorLayers() will return its data in.
Public Types inherited from FieldRes
typedef FieldRes | class_type
typedef boost::intrusive_ptr< FieldRes > | Ptr
typedef std::vector< Ptr > | Vec
Public Types inherited from FieldBase
typedef FieldBase | class_type
typedef boost::intrusive_ptr< FieldBase > | Ptr
Public Types inherited from RefBase
typedef boost::intrusive_ptr< RefBase > | Ptr
typedef boost::weak_ptr< RefBase > | WeakPtr

## Public Member Functions

virtual Data_T | lsSample (const V3d &lsP) const =0
Data_T | typedFloatMetadata (const std::string &name, const Data_T &defaultVal) const
| Calls either sampleFloatMetadata() if the ProceduralField is scalar (half, float, or double), or sampleVecFloatMetadata() if the field is vector (V3h, V3f, V3d).
double | typedFloatMetadata (const std::string &name, const double &defaultVal) const
float | typedFloatMetadata (const std::string &name, const float &defaultVal) const
half | typedFloatMetadata (const std::string &name, const half &defaultVal) const
V3d | typedFloatMetadata (const std::string &name, const V3d &defaultVal) const
V3f | typedFloatMetadata (const std::string &name, const V3f &defaultVal) const
V3h | typedFloatMetadata (const std::string &name, const V3h &defaultVal) const
Data_T | typedIntMetadata (const std::string &name, const Data_T &defaultVal) const
| Calls either sampleIntMetadata() if the ProceduralField is scalar (half, float, or double), or sampleVecIntMetadata() if the field is vector (V3h, V3f, V3d).
double | typedIntMetadata (const std::string &name, const double &defaultVal) const
float | typedIntMetadata (const std::string &name, const float &defaultVal) const
half | typedIntMetadata (const std::string &name, const half &defaultVal) const
V3d | typedIntMetadata (const std::string &name, const V3d &defaultVal) const
V3f | typedIntMetadata (const std::string &name, const V3f &defaultVal) const
V3h | typedIntMetadata (const std::string &name, const V3h &defaultVal) const
virtual FIELD3D_CLASSNAME_CLASSTYPE_IMPLEMENTATION Data_T | value (int i, int j, int k) const =0
| Transforms the point from voxel space to subclass's space and calls the appropriate sample function.
virtual | ~ProceduralField ()
| Destructor.
Public Member Functions inherited from Field< Data_T >
const_iterator | cbegin () const
| Const iterator to first element. "cbegin" matches the tr1 c++ standard.
const_iterator | cbegin (const Box3i &subset) const
| Const iterator to first element of specific subset.
const_iterator | cend () const
| Const iterator pointing one element past the last valid one.
const_iterator | cend (const Box3i &subset) const
| Const iterator pointing one element past the last valid one (for a subset).
virtual std::string | dataTypeString () const
virtual | ~Field ()
| Dtor.
Public Member Functions inherited from FieldRes
V3i const | dataResolution () const
const Box3i & | dataWindow () const
| Returns the data window. Any coordinate inside this window is safe to pass to value() in the Field subclass.
const Box3i & | extents () const
| Returns the extents of the data. This signifies the relevant area that the data exists over. However, the data window (below) may be smaller than the extents, in which case it is only safe to call value() for those coordinate inside the data window.
| FieldRes ()
| This constructor ensures that we have a valid mapping at all times.
| FieldRes (const FieldRes &src)
| Base class copy constructor.
bool | isInBounds (int i, int j, int k) const
| Returns true is the indicies are in bounds of the data window.
FieldMapping::Ptr | mapping ()
| Returns a pointer to the mapping.
const FieldMapping::Ptr | mapping () const
| Returns a pointer to the mapping.
virtual void | mappingChanged ()
| Tells the subclass that the mapping changed.
virtual long long int | memSize () const
| Returns the memory usage (in bytes).
void | setMapping (FieldMapping::Ptr mapping)
| Sets the field's mapping.
virtual size_t | voxelCount () const
| Counts the number of voxels. For most fields, this is just the volume of the data window, but sparse data structures can override this to return a better value.
Public Member Functions inherited from FieldBase
| FieldBase ()
| Constructor.
| FieldBase (const FieldBase &)
| Copy Constructor.
virtual | ~FieldBase ()
| Destructor.
virtual std::string | className () const =0
| Returns the class name of the object. Used by the class pool and when writing the data to disk.
virtual std::string | classType () const =0
| Returns the full class type string.
virtual Ptr | clone () const =0
| Returns a pointer to a copy of the field, pure virtual so ensure derived classes properly implement it.
FieldMetadata & | metadata ()
| accessor to the m_metadata class
const FieldMetadata & | metadata () const
| Read only access to the m_metadata class.
void | copyMetadata (const FieldBase &field)
| Copies the metadata from a second field.
Public Member Functions inherited from RefBase
void | ref () const
| Used by boost::intrusive_pointer.
size_t | refcnt ()
| Used by boost::intrusive_pointer.
void | unref () const
| Used by boost::intrusive_pointer.
WeakPtr | weakPtr () const
| RefBase ()
| RefBase (const RefBase &)
| Copy constructor.
RefBase & | operator= (const RefBase &)
| Assignment operator.
virtual | ~RefBase ()
| Destructor.
virtual bool | checkRTTI (const char *typenameStr)=0
| This function is only implemented by concrete classes and triggers the actual RTTI check through matchRTTI();.
bool | matchRTTI (const char *typenameStr)
| Performs a check to see if the given typename string matches this class' This needs to be implemented in -all- subclasses, even abstract ones.
Public Member Functions inherited from MetadataCallback
virtual void | metadataHasChanged (const std::string &)
| Alerts the callback holder that the metadata has changed.

## Static Public Member Functions

static DEFINE_FIELD_RTTI_ABSTRACT_CLASS const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from Field< Data_T >
static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from FieldRes
static const char * | staticClassName ()
static const char * | staticClassType ()
Static Public Member Functions inherited from FieldBase
static const char * | staticClassName ()
static const char * | staticClassType ()
static const char * | staticClassType ()

## Private Types

typedef Field< Data_T > | base

## Static Private Attributes

static TemplatedFieldType< ProceduralField< Data_T > > | ms_classType

## Additional Inherited Members

Public Attributes inherited from Field< Data_T >
| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from FieldRes
| DEFINE_FIELD_RTTI_ABSTRACT_CLASS
Public Attributes inherited from FieldBase
std::string | attribute
| Optional name of the attribute the field represents.
std::string | name
| Optional name of the field.
Protected Types inherited from FieldRes
typedef MatrixFieldMapping | default_mapping
Protected Attributes inherited from FieldRes
Box3i | m_dataWindow
| Defines the area where data is allocated. This should be treated as a closed (i.e. inclusive) interval.
Box3i | m_extents
| Defines the extents of the the storage. This may be larger or smaller than the data window, and in the case where it is larger, care must be taken not to access voxels outside the data window. This should be treated as a closed (i.e. inclusive) interval.
FieldMapping::Ptr | m_mapping
| Pointer to the field's mapping.

## Detailed Description

template<class Data_T>
class ProceduralField< Data_T >

This class generalizes the Field concept to fields that don't necessarily contain voxel data. This is technically wrong (it's not true that a perlin noise volume IS-A Field) but it lends great flexibility to the Field concept.

So what happens when a ProceduralField is accessed using the Field interface? ProceduralField itself implements value() such that it automatically point-samples the field instead of accessing a particular voxel. This makes the ProceduralField seem as a regular Field to anyone using that interface.

The interesting part comes when we look at interpolation. Regular Field objects use Interpolator objects to produce values in-between voxels. For ProceduralField, we instead want to point-sample in space, but other than that the resultant value can be handled the same.

It is also fine to interpolate the ProceduralField outside its bounds - just as it is with regular Fields. The difference is that ProceduralFields still return valid values outside its bounds.

By using ProceduralField, we can support purely procedural and hybrid procedural/discrete volumes, but to the functions that use them, they all function the same.

Definition at line 120 of file ProceduralField.h.

## Member Typedef Documentation

## Ptr

template<class Data_T>

typedef boost::intrusive_ptr<ProceduralField> ProceduralField< Data_T >::Ptr

Definition at line 127 of file ProceduralField.h.

## LinearInterp

template<class Data_T>

typedef ProceduralFieldLookup<Data_T> ProceduralField< Data_T >::LinearInterp

Definition at line 129 of file ProceduralField.h.

## CubicInterp

template<class Data_T>

typedef ProceduralFieldLookup<Data_T> ProceduralField< Data_T >::CubicInterp

Definition at line 130 of file ProceduralField.h.

## class_type

template<class Data_T>

typedef ProceduralField<Data_T> ProceduralField< Data_T >::class_type

Definition at line 134 of file ProceduralField.h.

## base

template<class Data_T>

typedef Field<Data_T> ProceduralField< Data_T >::base

private

Definition at line 188 of file ProceduralField.h.

## Constructor & Destructor Documentation

## ~ProceduralField()

template<class Data_T>

virtual ProceduralField< Data_T >::~ProceduralField | ( |  | ) |

inline virtual

Destructor.

Definition at line 150 of file ProceduralField.h.

{ /* Empty */ }

## Member Function Documentation

## staticClassName()

template<class Data_T>

DEFINE_FIELD_RTTI_ABSTRACT_CLASS const char * ProceduralField< Data_T >::staticClassName | ( |  | ) |

inline static

Definition at line 137 of file ProceduralField.h.

{
return "ProceduralField";
}

## staticClassType()

template<class Data_T>

const char * ProceduralField< Data_T >::staticClassType | ( |  | ) |

inline static

Definition at line 142 of file ProceduralField.h.

{
return ProceduralField<Data_T>::ms_classType.name();
}
FieldBase::name
std::string name
Optional name of the field.
Definition Field.h:171
ProceduralField
Definition ProceduralField.h:121

## lsSample()

template<class Data_T>

virtual Data_T ProceduralField< Data_T >::lsSample | ( | const V3d & | lsP | ) | const

pure virtual

Referenced by ProceduralFieldLookup< Data_T >::sample().

## value()

template<class Data_T>

virtual FIELD3D_CLASSNAME_CLASSTYPE_IMPLEMENTATION Data_T ProceduralField< Data_T >::value | ( | int | i,
|  | int | j,
|  | int | k ) const

pure virtual

Transforms the point from voxel space to subclass's space and calls the appropriate sample function.

Implements Field< Data_T >.

## typedIntMetadata() [1/7]

template<class Data_T>

Data_T ProceduralField< Data_T >::typedIntMetadata | ( | const std::string & | name,
|  | const Data_T & | defaultVal ) const

Calls either sampleIntMetadata() if the ProceduralField is scalar (half, float, or double), or sampleVecIntMetadata() if the field is vector (V3h, V3f, V3d).

## typedFloatMetadata() [1/7]

template<class Data_T>

Data_T ProceduralField< Data_T >::typedFloatMetadata | ( | const std::string & | name,
|  | const Data_T & | defaultVal ) const

Calls either sampleFloatMetadata() if the ProceduralField is scalar (half, float, or double), or sampleVecFloatMetadata() if the field is vector (V3h, V3f, V3d).

## typedIntMetadata() [2/7]

half ProceduralField< half >::typedIntMetadata | ( | const std::string & | name,
|  | const half & | defaultVal ) const

inline

Definition at line 215 of file ProceduralField.h.

{
return metadata().intMetadata(name, static_cast<int>(defaultVal));
}
FieldBase::metadata
FieldMetadata & metadata()
accessor to the m_metadata class
Definition Field.h:155
FieldMetadata::intMetadata
int intMetadata(const std::string &name, const int defaultVal) const
Tries to retrieve an int metadata value. Returns the specified default value if no metadata was found...
Definition FieldMetadata.cpp:158

## typedIntMetadata() [3/7]

float ProceduralField< float >::typedIntMetadata | ( | const std::string & | name,
|  | const float & | defaultVal ) const

inline

Definition at line 225 of file ProceduralField.h.

{
return metadata().intMetadata(name, static_cast<int>(defaultVal));
}

## typedIntMetadata() [4/7]

double ProceduralField< double >::typedIntMetadata | ( | const std::string & | name,
|  | const double & | defaultVal ) const

inline

Definition at line 235 of file ProceduralField.h.

{
return metadata().intMetadata(name, static_cast<int>(defaultVal));
}

## typedIntMetadata() [5/7]

V3h ProceduralField< V3h >::typedIntMetadata | ( | const std::string & | name,
|  | const V3h & | defaultVal ) const

inline

Definition at line 245 of file ProceduralField.h.

{
return V3h(metadata().vecIntMetadata(name, defaultVal));
}
V3h
Imath::Vec3< half > V3h
Definition SpiMathLib.h:72

## typedIntMetadata() [6/7]

V3f ProceduralField< V3f >::typedIntMetadata | ( | const std::string & | name,
|  | const V3f & | defaultVal ) const

inline

Definition at line 255 of file ProceduralField.h.

{
return V3f(metadata().vecIntMetadata(name, defaultVal));
}
V3f
Imath::V3f V3f
Definition SpiMathLib.h:73

## typedIntMetadata() [7/7]

V3d ProceduralField< V3d >::typedIntMetadata | ( | const std::string & | name,
|  | const V3d & | defaultVal ) const

inline

Definition at line 265 of file ProceduralField.h.

{
return V3d(metadata().vecIntMetadata(name, defaultVal));
}
V3d
Imath::V3d V3d
Definition SpiMathLib.h:74

## typedFloatMetadata() [2/7]

half ProceduralField< half >::typedFloatMetadata | ( | const std::string & | name,
|  | const half & | defaultVal ) const

inline

Definition at line 275 of file ProceduralField.h.

{
return metadata().floatMetadata(name, static_cast<float>(defaultVal));
}
FieldMetadata::floatMetadata
float floatMetadata(const std::string &name, const float defaultVal) const
Tries to retrieve a float metadata value. Returns the specified default value if no metadata was foun...
Definition FieldMetadata.cpp:128

## typedFloatMetadata() [3/7]

float ProceduralField< float >::typedFloatMetadata | ( | const std::string & | name,
|  | const float & | defaultVal ) const

inline

Definition at line 285 of file ProceduralField.h.

{
return metadata().floatMetadata(name, defaultVal);
}

## typedFloatMetadata() [4/7]

double ProceduralField< double >::typedFloatMetadata | ( | const std::string & | name,
|  | const double & | defaultVal ) const

inline

Definition at line 295 of file ProceduralField.h.

{
return metadata().floatMetadata(name, static_cast<float>(defaultVal));
}

## typedFloatMetadata() [5/7]

V3h ProceduralField< V3h >::typedFloatMetadata | ( | const std::string & | name,
|  | const V3h & | defaultVal ) const

inline

Definition at line 305 of file ProceduralField.h.

{
return V3h(metadata().vecFloatMetadata(name, defaultVal));
}

## typedFloatMetadata() [6/7]

V3f ProceduralField< V3f >::typedFloatMetadata | ( | const std::string & | name,
|  | const V3f & | defaultVal ) const

inline

Definition at line 315 of file ProceduralField.h.

{
return V3f(metadata().vecFloatMetadata(name, defaultVal));
}

## typedFloatMetadata() [7/7]

V3d ProceduralField< V3d >::typedFloatMetadata | ( | const std::string & | name,
|  | const V3d & | defaultVal ) const

inline

Definition at line 325 of file ProceduralField.h.

{
return V3d(metadata().vecFloatMetadata(name, defaultVal));
}

## Member Data Documentation

## ms_classType

template<class Data_T>

TemplatedFieldType<ProceduralField<Data_T> > ProceduralField< Data_T >::ms_classType

static private

Definition at line 184 of file ProceduralField.h.

Referenced by ProceduralField< half >::staticClassType().

The documentation for this class was generated from the following file:

- export/ProceduralField.h